## ike 2.0.3+dfsg

=== CMakeLists.txt ===
#
# Shrew Soft VPN / IKE Tools
# Cross Platform Make File
#
# author : Matthew Grooms
#        : mgrooms@shrew.net
#        : Copyright 2007, Shrew Soft Inc
#

project( IKE )

#
# Unix Target Constants
#

add_definitions( -DUNIX )

include( CheckCSourceCompiles )
include( CheckLibraryExists )

set(
	RELVER
	"2.0.3" )

subdirs(
	source/iked
	source/libike
	source/libip
	source/libith
	source/liblog
	source/libpfk )

set(
	SEARCH_INC
	/usr/include
	/usr/local/include )

set(
	SEARCH_LIB
	/usr/lib
	/usr/local/lib )

set(
	SEARCH_BIN
	/usr/local/bin
	/usr/pkg/bin
	/usr/bin )

set(
	SEARCH_SYS
	/usr/local
	/usr/share
	/usr )

#
# Path Option Checks
#

if( NOT EXISTS ${CMAKE_INSTALL_PREFIX} )

	set(
		CMAKE_INSTALL_PREFIX
		"/usr" )

endif( NOT EXISTS ${CMAKE_INSTALL_PREFIX} )

message(
	STATUS 
	"Using install prefix ${CMAKE_INSTALL_PREFIX} ..." )

# etc path

if( ETCDIR )

	set(	PATH_ETC
		${ETCDIR} )

else( ETCDIR )

	if( EXISTS ${CMAKE_INSTALL_PREFIX}/etc )

		set(	PATH_ETC
			"${CMAKE_INSTALL_PREFIX}/etc" )

	else( EXISTS ${CMAKE_INSTALL_PREFIX}/etc )
		
		set(	PATH_ETC
			"/etc" )

	endif( EXISTS ${CMAKE_INSTALL_PREFIX}/etc )

endif( ETCDIR )

message(
	STATUS
	"Using etc path ${PATH_ETC} ..." )

# man path

if( MANDIR )

	set(	PATH_MAN
		${MANDIR} )

else( MANDIR )

	find_path(
		PATH_MAN
		NAMES "man"
		PATHS ${SEARCH_SYS}
		NO_DEFAULT_PATH )

	if( PATH_MAN )

		set(	PATH_MAN
			"${PATH_MAN}/man" )

	else( PATH_MAN )

		set(	PATH_MAN
			"${CMAKE_INSTALL_PREFIX}/man" )

	endif( PATH_MAN )

endif( MANDIR )

message(
	STATUS
	"Using man path ${PATH_MAN} ..." )

if( KRNINC )

	set(
		INC_KERNEL_DIR
		${KRNINC} )

	message(
		STATUS
		"Using kernel include path ${INC_KERNEL_DIR} ..." )

endif( KRNINC )

#
# PreRequisite Checks
#

find_path(
	PATH_INC_CRYPTO
	NAMES "openssl/evp.h"
	PATHS ${SEARCH_INC} )

if( NOT PATH_INC_CRYPTO )

	message(
		FATAL_ERROR
		"Unable to locate openssl crypto include files" )

endif( NOT PATH_INC_CRYPTO )

find_library(
	PATH_LIB_CRYPTO
	NAMES "crypto"
	PATHS ${SEARCH_LIB} )

if( NOT PATH_LIB_CRYPTO )

	message(
		FATAL_ERROR
		"Unable to locate openssl crypto library file" )

endif( NOT PATH_LIB_CRYPTO )

find_package( Threads )

if( NOT CMAKE_USE_PTHREADS_INIT )

	message(
		FATAL_ERROR
		"Unable to locate required package : pthreads" )

endif( NOT CMAKE_USE_PTHREADS_INIT )

check_library_exists(
	${CMAKE_THREAD_LIBS_INIT}
	"pthread_mutex_timedlock"
	""
	FUNC_LIB_TIMEDLOCK )

if( FUNC_LIB_TIMEDLOCK )

	add_definitions( -DOPT_TIMEDLOCK )

endif( FUNC_LIB_TIMEDLOCK )

find_program(
	PATH_BIN_FLEX
	NAMES "flex"
	PATHS ${SEARCH_BIN} )

if( NOT PATH_BIN_FLEX )

	message(
		FATAL_ERROR
		"Unable to locate required binary : flex" )

endif( NOT PATH_BIN_FLEX )
		
message(
	STATUS 
	"Using binary ${PATH_BIN_FLEX} ..." )

find_program(
	PATH_BIN_BISON
	NAMES "bison"
	PATHS ${SEARCH_BIN} )

if( NOT PATH_BIN_BISON )

	message(
		FATAL_ERROR
		"Unable to locate required binary : bison" )

endif( NOT PATH_BIN_BISON )
		
message(
	STATUS 
	"Using binary ${PATH_BIN_BISON} ..." )

find_path(
	PATH_INC_NETIPSEC
	NAMES "ipsec.h"
	PATHS "/usr/include/netipsec" )

if( PATH_INC_NETIPSEC )

	add_definitions( -DOPT_NETIPSEC )

endif( PATH_INC_NETIPSEC )

find_library(
	PATH_LIB_RT
	NAMES "rt"
	PATHS ${SEARCH_LIB} )

find_path(
	PATH_INC_PFKEYV2
	NAMES "net/pfkeyv2.h" "linux/pfkeyv2.h"
	PATHS ${SEARCH_INC} ${INC_KERNEL_DIR} )

if( NOT PATH_INC_PFKEYV2 )

	message(
		FATAL_ERROR
		"Unable to locate system pfkeyv2 include file" )

endif( NOT PATH_INC_PFKEYV2 )

#
# Build Option Checks
#

OPTION( DEBUG  "include Debug Symbol support" )
OPTION( NATT   "include NAT Traversal support" )
OPTION( LDAP   "include LDAP Authentication support" )
OPTION( QTGUI  "include Client QT GUI support" )

# Debug Symbols Option

if( DEBUG )

	add_definitions( -g )

endif( DEBUG )

# NAT Traversion option

if( NATT )

	check_c_source_compiles(
		"
		#ifdef __linux__
		# include <inttypes.h>
		# include <linux/pfkeyv2.h>
		#else
		# include <sys/types.h>
		# include <net/pfkeyv2.h>
                #endif

		int main()
		{
			struct sadb_x_nat_t_type test;

			return 0;
		}
		"
		NATT_FOUND )

	if( NOT NATT_FOUND )

		message(
			FATAL_ERROR
			"Unable to locate required NAT-T pfkey structures" )

	endif( NOT NATT_FOUND )

	# success

	message(
		STATUS 
		"Enabled NAT Traversal support ..." )

	add_definitions( -DOPT_NATT )

endif( NATT )

# LDAP support option

if( LDAP )

	# ldap include

	find_path(
		PATH_INC_LDAP
		NAMES "ldap.h"
		PATHS ${SEARCH_INC} )

	if( NOT PATH_INC_LDAP )

		message(
			FATAL_ERROR
			"Unable to locate LDAP include file" )

	endif( NOT PATH_INC_LDAP )

	# ldap libraries

	find_library(
		PATH_LIB_LDAP
		NAMES "ldap"
		PATHS ${SEARCH_LIB} )

	find_library(
		PATH_LIB_LBER
		NAMES "lber"
		PATHS ${SEARCH_LIB} )

	if( NOT PATH_LIB_LDAP OR NOT PATH_LIB_LBER )

		message(
			FATAL_ERROR
			"Unable to locate LDAP library file" )

	endif( NOT PATH_LIB_LDAP OR NOT PATH_LIB_LBER )

	# success

	message( 
		STATUS
		"Enabled LDAP Authentication support ..." )

	add_definitions( -DOPT_LDAP )

endif( LDAP )

# Client GUI option

if( QTGUI )

	add_definitions( -DQT_THREAD_SUPPORT )

	set( QT_MT_REQUIRED TRUE )

	find_package( Qt3 )

	if( NOT QT_FOUND )

		message(
			FATAL_ERROR
			"Unable to locate required package : QT" )

	endif( NOT QT_FOUND )
		
	# success

	message(
		STATUS 
		"Enabled Client QT GUI support ..." )

	add_definitions( ${QT_DEFINITIONS} )

	add_subdirectory( source/ikea )
	add_subdirectory( source/ikec )

endif( QTGUI )

=== source/ikea/CMakeLists.txt ===
#
# Shrew Soft VPN / Access Manager Application
# Cross Platform Make File
#
# author : Matthew Grooms
#        : mgrooms@shrew.net
#        : Copyright 2007, Shrew Soft Inc
#

include_directories(
	${IKE_SOURCE_DIR}/source/
	${IKE_SOURCE_DIR}/source/libip
	${QT_INCLUDE_DIR} )

link_directories(
	${IKE_SOURCE_DIR}/source/libip )

set(
	UIC_FILES
	site.ui
	root.ui
	topology.ui
	about.ui )

set(
	IMG_FILES
	png/policy_exc.png
	png/policy_inc.png
	png/site.png
	png/site_add.png
	png/site_con.png
	png/site_del.png
	png/site_mod.png
	png/ikea.png )

qt_wrap_ui(
	LIB_FILES
	INC_FILES
	CPP_FILES
	${UIC_FILES} )

qt_wrap_cpp(
	LIB_FILES
	MOC_FILES
	${INC_FILES} )

add_executable(
	ikea
	main.cpp
	ikea.cpp
	config.cpp
	images.cxx
	${CPP_FILES} )

target_link_libraries(
	ikea
        ip
	pthread
	${QT_LIBRARIES} )

# qt image support

add_custom_command(  
	SOURCE ${IMG_FILES}
        COMMAND ${QT_UIC_EXECUTABLE}
        ARGS -embed ikea ${IMG_FILES} -o images.cxx
        TARGET ikea
        OUTPUTS images.cxx )

# install support

install(
	TARGETS ikea
	RUNTIME	DESTINATION bin )

install(
	FILES ikea.1
	DESTINATION ${PATH_MAN}/man1 )

=== source/ikec/CMakeLists.txt ===
#
# Shrew Soft VPN / Client Connect Application
# Cross Platform Make File
#
# author : Matthew Grooms
#        : mgrooms@shrew.net
#        : Copyright 2007, Shrew Soft Inc
#

include_directories(
	${IKE_SOURCE_DIR}/source/
	${IKE_SOURCE_DIR}/source/ikea
	${IKE_SOURCE_DIR}/source/iked
	${IKE_SOURCE_DIR}/source/libike
	${IKE_SOURCE_DIR}/source/libip
	${QT_INCLUDE_DIR} )

link_directories(
	${IKE_SOURCE_DIR}/source/libip )

set(
	UIC_FILES
	banner.ui
	filepass.ui
	root.ui )

set(
	IMG_FILES
	png/ikec.png )

qt_wrap_ui(
	LIB_FILES
	INC_FILES
	CPP_FILES
	${UIC_FILES} )

qt_wrap_cpp(
	LIB_FILES
	MOC_FILES
	${INC_FILES} )

add_executable(
	ikec
	main.cpp
	ikec.cpp
	../ikea/config.cpp
	images.cxx
	${CPP_FILES} )

target_link_libraries(
	ikec
	ike
        ip
	pthread
	${QT_LIBRARIES} )

# qt image support

add_custom_command(  
	SOURCE ${IMG_FILES}
        COMMAND ${QT_UIC_EXECUTABLE}
        ARGS -embed ikec ${IMG_FILES} -o images.cxx
        TARGET ikec
        OUTPUTS images.cxx )

# install support

install(
	TARGETS ikec
	RUNTIME	DESTINATION bin )

install(
	FILES ikec.1
	DESTINATION ${PATH_MAN}/man1 )

=== source/iked/CMakeLists.txt ===
#
# Shrew Soft VPN / IKE Daemon
# Cross Platform Make File
#
# author : Matthew Grooms
#        : mgrooms@shrew.net
#        : Copyright 2007, Shrew Soft Inc
#

add_definitions( -D PATH_CONF=\\"${PATH_ETC}\\" )

include_directories(
	${IKE_SOURCE_DIR}/source
	${IKE_SOURCE_DIR}/source/iked
	${IKE_SOURCE_DIR}/source/libike
	${IKE_SOURCE_DIR}/source/libith
	${IKE_SOURCE_DIR}/source/libip
	${IKE_SOURCE_DIR}/source/liblog
	${IKE_SOURCE_DIR}/source/libpfk
	${INC_KERNEL_DIR} )

link_directories(
	${IKE_SOURCE_DIR}/source/libike
	${IKE_SOURCE_DIR}/source/libith
	${IKE_SOURCE_DIR}/source/libip
	${IKE_SOURCE_DIR}/source/liblog
	${IKE_SOURCE_DIR}/source/libpfk )

add_executable(
	iked
	crypto.cpp
	conf.parse.cpp
	conf.token.cpp
	ike.cpp
	ike.exch.config.cpp
	ike.exch.inform.cpp
	ike.exch.phase1.cpp
	ike.exch.phase2.cpp
	ike.idb.config.cpp
	ike.idb.inform.cpp
	ike.idb.lists.cpp
	ike.idb.phase1.cpp
	ike.idb.phase2.cpp
	ike.idb.peer.cpp
	ike.idb.policy.cpp
	ike.idb.tunnel.cpp
	ike.idb.xch.cpp
	ike.io.admin.cpp
	ike.io.network.cpp
	ike.io.pfkey.cpp
	ike.keyfile.cpp
	ike.names.cpp
	ike.nethlp.cpp
	ike.packet.cpp
	ike.payload.cpp
	ike.peerid.cpp
	ike.policy.cpp
	ike.proposal.cpp
	ike.utility.cpp
	ike.xauth.cpp
	ike.xconf.cpp
	iked.cpp
	main.cpp )

target_link_libraries(
	iked
	ike
	ith
	ip
	log
	pfk
	crypt
	crypto
	pthread )

# linux realtime library

if( PATH_LIB_RT )

	target_link_libraries(
		iked
		rt )

endif( PATH_LIB_RT )

# LDAP support option

if( LDAP )

	include_directories(
		${PATH_INC_LDAP} )

	target_link_libraries(
		iked
		${PATH_LIB_LDAP}
		${PATH_LIB_LBER} )

endif( LDAP )

set_source_files_properties(
	conf.parse.cpp GENERATED,
	conf.token.cpp GENERATED )

# Custom target for parser

add_custom_target( ConfParser echo "Creating Conf Parser" )

# Custom command for flex

add_custom_command(
	SOURCE conf.token.ll
	COMMAND ${PATH_BIN_FLEX}
	ARGS -d -oconf.token.cpp conf.token.ll
	TARGET ConfParser
	OUTPUTS conf.token.cpp )

# Custom command for bison

add_custom_command(
	SOURCE conf.parse.yy
	COMMAND ${PATH_BIN_BISON}
	ARGS -oconf.parse.cpp conf.parse.yy
	TARGET ConfParser
	OUTPUTS conf.parse.cpp conf.parse.hpp location.hh position.hh stack.hh )

# install support

install(
        TARGETS iked
        RUNTIME DESTINATION sbin )

install(
	FILES iked.8
	DESTINATION ${PATH_MAN}/man8 )

install(
	FILES iked.conf.5
	DESTINATION ${PATH_MAN}/man5 )

install(
	FILES iked.conf.sample
	DESTINATION ${PATH_ETC} )

=== source/libike/CMakeLists.txt ===
#
# Shrew Soft VPN / IKE Daemon Interface Library
# Cross Platform Make File
#
# author : Matthew Grooms
#        : mgrooms@shrew.net
#        : Copyright 2007, Shrew Soft Inc
#

include_directories(
        ${IKE_SOURCE_DIR}/source
        ${IKE_SOURCE_DIR}/source/iked
        ${IKE_SOURCE_DIR}/source/libike
        ${IKE_SOURCE_DIR}/source/libip )

add_library(
	ike SHARED
	libike.cpp )

set_target_properties(
	ike PROPERTIES
	VERSION ${RELVER}
	SOVERSION ${RELVER} )

# install support

install(
	TARGETS ike
	LIBRARY DESTINATION lib )

=== source/libip/CMakeLists.txt ===
#
# Shrew Soft VPN / IP Utility Library
# Cross Platform Make File
#
# author : Matthew Grooms
#        : mgrooms@shrew.net
#        : Copyright 2007, Shrew Soft Inc
#

include_directories(
	${IKE_SOURCE_DIR}/source
	${IKE_SOURCE_DIR}/source/libith )

add_library(
	ip
	libip.bdata.cpp
	libip.frag.cpp
	libip.packet.cpp
	libip.packet.dns.cpp
	libip.packet.ip.cpp
	libip.packet.udp.cpp
	libip.pcap.cpp
	libip.queue.cpp
	libip.route.unix.cpp
	utils.list.cpp )

set_target_properties(
	ip PROPERTIES
	VERSION ${RELVER}
	SOVERSION ${RELVER} )

=== source/libith/CMakeLists.txt ===
#
# Shrew Soft VPN / Timer and Thread Library
# Cross Platform Make File
#
# author : Matthew Grooms
#        : mgrooms@shrew.net
#        : Copyright 2007, Shrew Soft Inc
#

include_directories(
        ${IKE_SOURCE_DIR}/source )

add_library(
	ith
	libith.cpp )

set_target_properties(
	ith PROPERTIES
	VERSION ${RELVER}
	SOVERSION ${RELVER} )

=== source/libpfk/CMakeLists.txt ===
#
# Shrew Soft VPN / PF KEY Helper Library
# Cross Platform Make File
#
# author : Matthew Grooms
#        : mgrooms@shrew.net
#        : Copyright 2007, Shrew Soft Inc
#

include_directories(
        ${IKE_SOURCE_DIR}/source
	${INC_KERNEL_DIR} )

add_library(
	pfk SHARED
	libpfk.cpp )

set_target_properties(
        pfk PROPERTIES
	VERSION ${RELVER}
	SOVERSION ${RELVER} )

# install support

install(
	TARGETS pfk
	LIBRARY DESTINATION lib )

## ike 2.1.0+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -20,12 +20,13 @@
 
 set(
 	RELVER
-	"2.0.3" )
+	"2.1.0" )
 
 subdirs(
 	source/iked
 	source/libike
 	source/libip
+	source/libidb
 	source/libith
 	source/liblog
 	source/libpfk )
@@ -263,6 +264,7 @@
 OPTION( NATT   "include NAT Traversal support" )
 OPTION( LDAP   "include LDAP Authentication support" )
 OPTION( QTGUI  "include Client QT GUI support" )
+OPTION( TESTS  "include library test programs" )
 
 # Debug Symbols Option
 
@@ -393,4 +395,17 @@
 
 endif( QTGUI )
 
-
+# Library Test Programs
+
+if( TESTS )
+
+	message(
+		STATUS 
+		"Building library test programs ..." )
+
+	add_subdirectory( source/test_ith )
+
+endif( TESTS )
+
+
+

=== source/ikea/CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,9 @@
 
 include_directories(
 	${IKE_SOURCE_DIR}/source/
-	${IKE_SOURCE_DIR}/source/libip
+	${IKE_SOURCE_DIR}/source/libidb
+	${IKE_SOURCE_DIR}/source/libith
+	${IKE_SOURCE_DIR}/source/liblog
 	${QT_INCLUDE_DIR} )
 
 link_directories(
@@ -19,11 +21,13 @@
 	UIC_FILES
 	site.ui
 	root.ui
+	conflict.ui
 	topology.ui
 	about.ui )
 
 set(
 	IMG_FILES
+	png/logo_ssoft.png
 	png/policy_exc.png
 	png/policy_inc.png
 	png/site.png
@@ -54,7 +58,9 @@
 
 target_link_libraries(
 	ikea
-        ip
+        idb
+        ith
+        log
 	pthread
 	${QT_LIBRARIES} )

## ike 2.1.4+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -20,7 +20,7 @@
 
 set(
 	RELVER
-	"2.1.0" )
+	"2.1.4" )
 
 subdirs(
 	source/iked

=== source/ikec/CMakeLists.txt ===
--- 
+++ 
@@ -12,6 +12,9 @@
 	${IKE_SOURCE_DIR}/source/ikea
 	${IKE_SOURCE_DIR}/source/iked
 	${IKE_SOURCE_DIR}/source/libike
+	${IKE_SOURCE_DIR}/source/libidb
+	${IKE_SOURCE_DIR}/source/libith
+	${IKE_SOURCE_DIR}/source/liblog
 	${IKE_SOURCE_DIR}/source/libip
 	${QT_INCLUDE_DIR} )
 
@@ -50,7 +53,9 @@
 target_link_libraries(
 	ikec
 	ike
-        ip
+        idb
+        ith
+        log
 	pthread
 	${QT_LIBRARIES} )
 
@@ -72,3 +77,4 @@
 install(
 	FILES ikec.1
 	DESTINATION ${PATH_MAN}/man1 )
+

## ike 2.1.5+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,6 +9,11 @@
 
 project( IKE )
 
+cmake_minimum_required( VERSION 2.4 )
+if( COMMAND cmake_policy )
+	cmake_policy( SET CMP0003 NEW )
+endif( COMMAND cmake_policy )
+
 #
 # Unix Target Constants
 #
@@ -20,7 +25,7 @@
 
 set(
 	RELVER
-	"2.1.4" )
+	"2.1" )
 
 subdirs(
 	source/iked

=== source/ikea/CMakeLists.txt ===
--- 
+++ 
@@ -58,9 +58,10 @@
 
 target_link_libraries(
 	ikea
-        idb
-        ith
-        log
+	idb
+	ith
+	log
+	crypto
 	pthread
 	${QT_LIBRARIES} )
 
@@ -68,10 +69,10 @@
 
 add_custom_command(  
 	SOURCE ${IMG_FILES}
-        COMMAND ${QT_UIC_EXECUTABLE}
-        ARGS -embed ikea ${IMG_FILES} -o images.cxx
-        TARGET ikea
-        OUTPUTS images.cxx )
+	COMMAND ${QT_UIC_EXECUTABLE}
+	ARGS -embed ikea ${IMG_FILES} -o images.cxx
+	TARGET ikea
+	OUTPUTS images.cxx )
 
 # install support

=== source/ikec/CMakeLists.txt ===
--- 
+++ 
@@ -53,9 +53,10 @@
 target_link_libraries(
 	ikec
 	ike
-        idb
-        ith
-        log
+	idb
+	ith
+	log
+	crypto
 	pthread
 	${QT_LIBRARIES} )
 
@@ -63,10 +64,10 @@
 
 add_custom_command(  
 	SOURCE ${IMG_FILES}
-        COMMAND ${QT_UIC_EXECUTABLE}
-        ARGS -embed ikec ${IMG_FILES} -o images.cxx
-        TARGET ikec
-        OUTPUTS images.cxx )
+	COMMAND ${QT_UIC_EXECUTABLE}
+	ARGS -embed ikec ${IMG_FILES} -o images.cxx
+	TARGET ikec
+	OUTPUTS images.cxx )
 
 # install support

=== source/iked/CMakeLists.txt ===
--- 
+++ 
@@ -13,6 +13,7 @@
 	${IKE_SOURCE_DIR}/source
 	${IKE_SOURCE_DIR}/source/iked
 	${IKE_SOURCE_DIR}/source/libike
+	${IKE_SOURCE_DIR}/source/libidb
 	${IKE_SOURCE_DIR}/source/libith
 	${IKE_SOURCE_DIR}/source/libip
 	${IKE_SOURCE_DIR}/source/liblog
@@ -21,6 +22,7 @@
 
 link_directories(
 	${IKE_SOURCE_DIR}/source/libike
+	${IKE_SOURCE_DIR}/source/libidb
 	${IKE_SOURCE_DIR}/source/libith
 	${IKE_SOURCE_DIR}/source/libip
 	${IKE_SOURCE_DIR}/source/liblog
@@ -31,6 +33,7 @@
 	crypto.cpp
 	conf.parse.cpp
 	conf.token.cpp
+	dhcp.cpp
 	ike.cpp
 	ike.exch.config.cpp
 	ike.exch.inform.cpp
@@ -44,7 +47,7 @@
 	ike.idb.peer.cpp
 	ike.idb.policy.cpp
 	ike.idb.tunnel.cpp
-	ike.idb.xch.cpp
+	ike.idb.exch.cpp
 	ike.io.admin.cpp
 	ike.io.network.cpp
 	ike.io.pfkey.cpp
@@ -56,7 +59,7 @@
 	ike.peerid.cpp
 	ike.policy.cpp
 	ike.proposal.cpp
-	ike.utility.cpp
+	ike.socket.cpp
 	ike.xauth.cpp
 	ike.xconf.cpp
 	iked.cpp
@@ -65,6 +68,7 @@
 target_link_libraries(
 	iked
 	ike
+	idb
 	ith
 	ip
 	log
@@ -72,16 +76,6 @@
 	crypt
 	crypto
 	pthread )
-
-# linux realtime library
-
-if( PATH_LIB_RT )
-
-	target_link_libraries(
-		iked
-		rt )
-
-endif( PATH_LIB_RT )
 
 # LDAP support option

=== source/libidb/CMakeLists.txt ===
#
# Shrew Soft VPN / Internal Object Database
# Cross Platform Make File
#
# author : Matthew Grooms
#        : mgrooms@shrew.net
#        : Copyright 2007, Shrew Soft Inc
#

include_directories(
	${IKE_SOURCE_DIR}/source
	${IKE_SOURCE_DIR}/source/libip
	${IKE_SOURCE_DIR}/source/liblog
	${IKE_SOURCE_DIR}/source/libith )

add_library(
	idb
	libidb.cpp
	base64.cpp )

set_target_properties(
	idb PROPERTIES
	VERSION ${RELVER}
	SOVERSION ${RELVER} )

=== source/libike/CMakeLists.txt ===
--- 
+++ 
@@ -11,6 +11,9 @@
         ${IKE_SOURCE_DIR}/source
         ${IKE_SOURCE_DIR}/source/iked
         ${IKE_SOURCE_DIR}/source/libike
+        ${IKE_SOURCE_DIR}/source/libidb
+        ${IKE_SOURCE_DIR}/source/libith
+        ${IKE_SOURCE_DIR}/source/liblog
         ${IKE_SOURCE_DIR}/source/libip )
 
 add_library(

=== source/libip/CMakeLists.txt ===
--- 
+++ 
@@ -9,11 +9,12 @@
 
 include_directories(
 	${IKE_SOURCE_DIR}/source
+	${IKE_SOURCE_DIR}/source/libidb
+	${IKE_SOURCE_DIR}/source/liblog
 	${IKE_SOURCE_DIR}/source/libith )
 
 add_library(
 	ip
-	libip.bdata.cpp
 	libip.frag.cpp
 	libip.packet.cpp
 	libip.packet.dns.cpp
@@ -21,8 +22,7 @@
 	libip.packet.udp.cpp
 	libip.pcap.cpp
 	libip.queue.cpp
-	libip.route.unix.cpp
-	utils.list.cpp )
+	libip.route.cpp )
 
 set_target_properties(
 	ip PROPERTIES

=== source/libith/CMakeLists.txt ===
--- 
+++ 
@@ -14,6 +14,17 @@
 	ith
 	libith.cpp )
 
+# linux realtime library
+
+if( PATH_LIB_RT )
+
+	target_link_libraries(
+		ith
+		rt )
+
+endif( PATH_LIB_RT )
+
+
 set_target_properties(
 	ith PROPERTIES
 	VERSION ${RELVER}

=== source/liblog/CMakeLists.txt ===
#
# Shrew Soft VPN / Log Facility Library
# Cross Platform Make File
#
# author : Matthew Grooms
#        : mgrooms@shrew.net
#        : Copyright 2007, Shrew Soft Inc
#

include_directories(
        ${IKE_SOURCE_DIR}/source
        ${IKE_SOURCE_DIR}/source/libith )

add_library(
	log
	liblog.cpp )

set_target_properties(
	log PROPERTIES
	VERSION ${RELVER}
	SOVERSION ${RELVER} )

=== source/libpfk/CMakeLists.txt ===
--- 
+++ 
@@ -9,6 +9,9 @@
 
 include_directories(
         ${IKE_SOURCE_DIR}/source
+        ${IKE_SOURCE_DIR}/source/libidb
+        ${IKE_SOURCE_DIR}/source/libith
+        ${IKE_SOURCE_DIR}/source/liblog
 	${INC_KERNEL_DIR} )
 
 add_library(

=== source/test_ith/CMakeLists.txt ===
#
# Shrew Soft VPN / IKE Daemon
# Cross Platform Make File
#
# author : Matthew Grooms
#        : mgrooms@shrew.net
#        : Copyright 2007, Shrew Soft Inc
#

include_directories(
	${IKE_SOURCE_DIR}/source
	${IKE_SOURCE_DIR}/source/libith )

link_directories(
	${IKE_SOURCE_DIR}/source/libith )

add_executable(
	test_ith_timer
	main.cpp )

target_link_libraries(
	test_ith_timer
	ith
	pthread )

## ike 2.1.7+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,7 +25,7 @@
 
 set(
 	RELVER
-	"2.1" )
+	"2.1.7" )
 
 subdirs(
 	source/iked
@@ -78,19 +78,22 @@
 
 if( ETCDIR )
 
-	set(	PATH_ETC
+	set(
+		PATH_ETC
 		${ETCDIR} )
 
 else( ETCDIR )
 
 	if( EXISTS ${CMAKE_INSTALL_PREFIX}/etc )
 
-		set(	PATH_ETC
+		set(
+			PATH_ETC
 			"${CMAKE_INSTALL_PREFIX}/etc" )
 
 	else( EXISTS ${CMAKE_INSTALL_PREFIX}/etc )
 		
-		set(	PATH_ETC
+		set(
+			PATH_ETC
 			"/etc" )
 
 	endif( EXISTS ${CMAKE_INSTALL_PREFIX}/etc )
@@ -101,11 +104,42 @@
 	STATUS
 	"Using etc path ${PATH_ETC} ..." )
 
+# lib path
+
+if( LIBDIR )
+
+	set(
+		PATH_LIB
+		${LIBDIR} )
+
+else( LIBDIR )
+
+	if( EXISTS ${CMAKE_INSTALL_PREFIX}/lib )
+
+		set(
+			PATH_LIB
+			"${CMAKE_INSTALL_PREFIX}/lib" )
+
+	else( EXISTS ${CMAKE_INSTALL_PREFIX}/lib )
+		
+		set(
+			PATH_LIB
+			"/usr/lib" )
+
+	endif( EXISTS ${CMAKE_INSTALL_PREFIX}/lib )
+
+endif( LIBDIR )
+
+message(
+	STATUS
+	"Using lib path ${PATH_LIB} ..." )
+
 # man path
 
 if( MANDIR )
 
-	set(	PATH_MAN
+	set(
+		PATH_MAN
 		${MANDIR} )
 
 else( MANDIR )
@@ -118,12 +152,14 @@
 
 	if( PATH_MAN )
 
-		set(	PATH_MAN
+		set(
+			PATH_MAN
 			"${PATH_MAN}/man" )
 
 	else( PATH_MAN )
 
-		set(	PATH_MAN
+		set(
+			PATH_MAN
 			"${CMAKE_INSTALL_PREFIX}/man" )
 
 	endif( PATH_MAN )
@@ -270,6 +306,9 @@
 OPTION( LDAP   "include LDAP Authentication support" )
 OPTION( QTGUI  "include Client QT GUI support" )
 OPTION( TESTS  "include library test programs" )
+OPTION( ETCDIR "custom etc install path" )
+OPTION( LIBDIR "custom library install path" )
+OPTION( MANDIR "custom man page install path" )
 
 # Debug Symbols Option

=== source/libike/CMakeLists.txt ===
--- 
+++ 
@@ -29,5 +29,5 @@
 
 install(
 	TARGETS ike
-	LIBRARY DESTINATION lib )
+	LIBRARY DESTINATION ${PATH_LIB} )

=== source/libpfk/CMakeLists.txt ===
--- 
+++ 
@@ -27,5 +27,5 @@
 
 install(
 	TARGETS pfk
-	LIBRARY DESTINATION lib )
+	LIBRARY DESTINATION ${PATH_LIB} )

=== debian/changelog ===
ike (2.1.7+dfsg-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Disable 0004_select.diff, 0006_terminate.diff which break connection
    setup. (Closes: #663223, reopens: #566673)

 -- Christoph Berg <myon@debian.org>  Mon, 12 Mar 2012 11:53:39 +0100

ike (2.1.7+dfsg-1) unstable; urgency=low

  * New upstream version.
  * debian/patches/0003_pktinfo.diff: Fix "FTBFS on kfreebsd-*: error: 'void*'
  		is not a pointer-to-object type" (Closes: #599947)
    This package still won't work with the Debians FreeBSD kernel, since it is
    missing IPSec / PFKEY support.
  * debian/patches/0004_select.diff, debian/patches/0006_terminate.diff:
    Fix "iked.real wakes up every 500ms even on idle" (Closes: #566673)
  * Switch to dpkg-source 3.0 (quilt) format
  * debian/control:
    - Standards-Version: 3.9.1: no changes required.
    - Add missing ${misc:Depends}
    - Although the FTBFS is now fixed, ike will not work on kFreeBSD, since it
      is missing PF_KEY support, switch to Architecture: linux-any.

 -- Philipp Matthias Hahn <pmhahn@debian.org>  Sat, 26 Feb 2011 11:42:11 +0100

ike (2.1.5+dfsg-2) unstable; urgency=medium

  * Fix "CVE-2010-3361: insecure library loading" caused by LD_LIBRARY_PATH=:
    in debian/wrappers/iked (Closes: #598292)
  * Fix "CVE-2010-3361: insecure library loading" caused by LD_LIBRARY_PATH=:
    in debian/wrappers/ike[ac] (Closes: #598293)

 -- Philipp Matthias Hahn <pmhahn@debian.org>  Fri, 08 Oct 2010 14:57:57 +0200

ike (2.1.5+dfsg-1) unstable; urgency=low

  * New upstream version.
  * debian/rules: update download-location.

 -- Philipp Matthias Hahn <pmhahn@debian.org>  Sun, 06 Dec 2009 09:09:25 +0100

ike (2.1.4+dfsg-4) unstable; urgency=low

  * debian/watch: Chaneg to new location
    http://www.shrew.net/download/ike/ike-(.*)-release.tgz

 -- Philipp Matthias Hahn <pmhahn@debian.org>  Tue, 06 Oct 2009 10:46:53 +0200

ike (2.1.4+dfsg-3) unstable; urgency=low

  * Fix incorrect init.d dependencies and runlevel in script/iked.
    (Closes: #545893) Thanks to Petter Reinholdtsen.
  * debian/ike.{pre,post}{inst,rm}: Fix "package installation fails" by
    ignoring errors during start on install. (Closes: #486656)
  * debian/control:
    - Standards-Version: 3.8.3: no changes required.
    - ike: Add reference to other IKEv1 daemons.
  * debian/rules: drop deprecated call of dh_desktop.

 -- Philipp Matthias Hahn <pmhahn@debian.org>  Tue, 06 Oct 2009 10:29:12 +0200

ike (2.1.4+dfsg-2) unstable; urgency=low

  * Fix circular dependency with iked.h & conf.token.hpp. (Closes: #521951)
  * debian/control: Standards-Version: 3.8.1
    - Fix script/iked to not start iked.real multiple times.

 -- Philipp Matthias Hahn <pmhahn@debian.org>  Tue, 07 Apr 2009 23:50:32 +0200

ike (2.1.4+dfsg-1) unstable; urgency=low

  * New upstream version.
  * debian/watch: Fix download location.

 -- Philipp Matthias Hahn <pmhahn@debian.org>  Thu, 13 Nov 2008 19:50:14 +0100

ike (2.1.3+dfsg-1) unstable; urgency=low

  * New upstream version. (Closes: #500139)
    - bug in check of remote IPv4 address (Closes: #500027)
  * debian/rules:
    - "dh_makeshlibs -n" because libraries are not public
    - Remove ${misc:Depends} from Depends-lines
    - add source/ikea/conflict.h, source/iked/etkey to FILESTOCLEAN
  * debian/wrapper/*
    - Do exec instead of forking
  * debian/control:
    - Bump Standards-Version to 3.8.0: no changes required
    - Adopt package on Nicolas request. Thanks for previous maintenance.
  * debian/{control,copyright,init.d,rules}
    - Strip trailing white spaces: s/\s\+$//
  * source/iked/iked.{8,conf.5}
    - Remove path-prefix /usr/local
  * Use script/iked instead of debian/ike.init

 -- Philipp Matthias Hahn <pmhahn@debian.org>  Wed, 22 Oct 2008 23:42:59 +0200

ike (2.1.0+dfsg-1) unstable; urgency=low

  * New upstream version.

 -- Nicolas Deschildre <ndeschildre@gmail.com>  Wed, 28 May 2008 00:07:17 +0200

ike (2.0.3+dfsg-1) unstable; urgency=low

  * Initial release (Closes: #482589)

 -- Nicolas Deschildre <ndeschildre@gmail.com>  Tue, 27 May 2008 19:45:32 +0200

=== debian/control ===
Source: ike
Section: net
Priority: extra
Maintainer: Philipp Matthias Hahn <pmhahn@debian.org>
Build-Depends: debhelper (>= 6.0.7~),
 flex,
 bison (>= 2.3),
 libqt3-mt-dev (>= 3.3),
 libssl-dev (>= 0.9),
 cmake (>= 2.4)
Standards-Version: 3.9.1
Homepage: http://www.shrew.net/

Package: ike
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: ike-qtgui
Provides: ike-server
Description:Shrew Soft VPN client - Daemon and libraries
 The Shrew Soft VPN client is a free IPsec VPN Client for FreeBSD, NetBSD,
 Linux and Windows operating systems. This product can be used to communicate
 with Open Source VPN servers (e.g. ipsec-tools) as well as some commercial
 VPN servers.
 .
 This package provides a IKEv1 (ipsec key exchange) daemon and librairies used
 to maintain a IPSec VPN connection. It provides similar functionality as
 racoon, OpenSwan, FreeSwan, StrongSwan, IsaKmpD but is more user-interactive.
 .
 Note: You should install the ike-qtgui package to have a graphical
 user interface to configure and use VPN connections.

Package: ike-qtgui
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description:Shrew Soft VPN client - Connection manager
 The Shrew Soft VPN Client is a free IPsec VPN Client for FreeBSD, NetBSD,
 Linux and Windows operating systems. This product can be used to communicate
 with Open Source VPN servers (e.g. ipsec-tools) as well as some commercial
 VPN servers.
 .
 This package provides the connection manager program, which allows one
 to create, manage and use VPN connections.

=== debian/rules ===
#!/usr/bin/make -f

# This has to be exported to make some magic below work.
export DH_OPTIONS

CONFIGURE = cmake

# Files to delete when cleaning
FILESREGEXTOCLEAN = *.so *.so.* *.a *.cxx cmake_install.cmake *.hh *.o CMakeFiles Makefile
FILESTOCLEAN += CMakeCache.txt
FILESTOCLEAN += cmake.check_cache
FILESTOCLEAN += CMakeOutput.log
FILESTOCLEAN += config.log
FILESTOCLEAN += install_manifest.txt
FILESTOCLEAN += warning.log
FILESTOCLEAN += source/ikea/about.h
FILESTOCLEAN += source/ikea/conflict.h
FILESTOCLEAN += source/ikea/ikea
FILESTOCLEAN += source/ikea/root.h
FILESTOCLEAN += source/ikea/site.h
FILESTOCLEAN += source/ikea/topology.h
FILESTOCLEAN += source/ikec/banner.h
FILESTOCLEAN += source/ikec/filepass.h
FILESTOCLEAN += source/ikec/ikec
FILESTOCLEAN += source/ikec/root.h
FILESTOCLEAN += source/iked/conf.parse.cpp
FILESTOCLEAN += source/iked/conf.parse.hpp
FILESTOCLEAN += source/iked/conf.token.cpp
FILESTOCLEAN += source/iked/etkey
FILESTOCLEAN += source/iked/iked

# Files to delete from the source archive to be in accordance with the Debian free software guidelines
DFSG_FILESTOCLEAN = ike/docs/*

VERSION:=$(shell dpkg-parsechangelog | sed -ne 's/^Version: \(.*\)+[^+]*$$/\1/p')
URL = http://www.shrew.net/download/ike/ike-$(VERSION)-release.tgz

DEB_HOST_ARCH_OS := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS 2>/dev/null)

ifeq ($(DEB_HOST_ARCH_OS), kfreebsd)
	# Debian FreeBSD kernel is missing IPSEC_NAT_T support, see README.TXT
	DEB_CONFIGURE_EXTRA_FLAGS += -DNATT=NO
else
	DEB_CONFIGURE_EXTRA_FLAGS += -DNATT=YES
endif

get-orig-source:
	mkdir tmp
	wget -O tmp/ike.tar.gz "$(URL)"
	tar zxvfC tmp/ike.tar.gz tmp
	$(RM) $(addprefix tmp/,$(DFSG_FILESTOCLEAN))
	mv tmp/ike tmp/ike-$(VERSION)+dfsg
	tar cvfC ike_$(VERSION)+dfsg.orig.tar tmp ike-$(VERSION)+dfsg
	gzip -9 ike_$(VERSION)+dfsg.orig.tar
	$(RM) -R tmp

configure: configure-stamp
configure-stamp:
	dh_testdir
	$(CONFIGURE) -DQTGUI=YES -DNATT=YES -DCMAKE_INSTALL_PREFIX:PATH=/usr -DETCDIR:PATH=/etc -DMANDIR:PATH=/usr/share/man -DDEBUG=YES $(DEB_CONFIGURE_EXTRA_FLAGS)
	touch $@

#Architecture
build: build-arch

build-arch: build-arch-stamp
build-arch-stamp: configure-stamp
	$(MAKE)
	touch $@

clean:
	dh_testdir
	$(RM) build-arch-stamp configure-stamp
# Cmake does not provide clean target. I have to do it manually.
	$(RM) $(FILESTOCLEAN)
	$(RM) -R $(foreach regex, $(FILESREGEXTOCLEAN), $(shell find . -name $(regex) -print))
	dh_clean

install: install-arch

install-arch:
	dh_testdir
	dh_testroot
	dh_clean -k -s
	dh_installdirs -s

	$(MAKE) DESTDIR=$(CURDIR)/debian/tmp install

# Rename the executables files
	mv debian/tmp/usr/bin/ikea debian/tmp/usr/bin/ikea.real
	mv debian/tmp/usr/bin/ikec debian/tmp/usr/bin/ikec.real
	mv debian/tmp/usr/sbin/iked debian/tmp/usr/sbin/iked.real
	dh_install -s
ifeq ($(DEB_HOST_ARCH_OS), kfreebsd)
	sed -e 's/socket natt/#&/' source/iked/iked.conf.sample >debian/ike/etc/iked.conf
else
	cat source/iked/iked.conf.sample >debian/ike/etc/iked.conf
endif
	mv debian/ike/etc/init.d/iked debian/ike/etc/init.d/ike

# Build architecture dependant packages using the common target.
binary-arch: build-arch install-arch
	dh_testdir
	dh_testroot
	dh_installchangelogs TODO.TXT
	dh_installdocs
	dh_installinit -p ike --onlyscripts --error-handler=ike_error
	dh_installman
	dh_lintian
	dh_strip
	dh_compress
	dh_fixperms
	dh_makeshlibs -n
	dh_installdeb
	dh_shlibdeps -l/usr/lib/ike
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary-indep:

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure get-orig-source

## ike 2.2.1%2Bdfsg

=== debian/changelog ===
ike (2.2.1+dfsg-6) unstable; urgency=medium

  * QA upload.
  * Fix FTBFS with openssl 1.1.0. Thanks to Adrian Bunk. (Closes: #828349)
  * Bump Standards-Version to 3.9.8.

 -- Chris Lamb <lamby@debian.org>  Sat, 12 Nov 2016 13:58:26 +0000

ike (2.2.1+dfsg-5) unstable; urgency=medium

  * QA upload.
  * Orphan package.

 -- Christian Hofstaedtler <zeha@debian.org>  Sun, 17 Jul 2016 18:55:09 +0000

ike (2.2.1+dfsg-4) unstable; urgency=medium

  * Link with pthread, fix FTBFS on arm64 (patch from Ubuntu).
    Thanks to Daniel T Chen <crimsun@ubuntu.com>
  * d/control: Add Vcs-{Git,Browser}
  * Fix lintian warning empty-short-license-in-dep5-copyright
  * Update Standards-Version to 3.9.6 (no further changes)

 -- Christian Hofstaedtler <zeha@debian.org>  Sun, 28 Jun 2015 00:24:32 +0200

ike (2.2.1+dfsg-3) unstable; urgency=medium

  * Add patch fixing possible crash in qikea

 -- Christian Hofstaedtler <zeha@debian.org>  Sun, 27 Jul 2014 01:07:47 +0200

ike (2.2.1+dfsg-2) unstable; urgency=medium

  * ike: Replace squeeze version of ike-qtgui (Closes: #734462)
  * Bump Standards-Version to 3.9.5 (no changes)

 -- Christian Hofstaedtler <zeha@debian.org>  Tue, 07 Jan 2014 15:22:27 +0100

ike (2.2.1+dfsg-1) unstable; urgency=low

  * New maintainer, reintroduce to unstable.
  * New upstream version.
    * GUI uses Qt4
    * New ikec command line tool
  * Conflict with ike-server meta-package, drop associated README.Debian
  * drop wrapper scripts and replace them with RPATH
  * Enable hardening flags
  * Switch to debhelper 9
  * Switch to source format 3.0 (quilt)
  * Bump Standards-Version to 3.9.4
  * Add Keywords to desktop file
  * Fix Error in German description
  * Expand Recommends

 -- Christian Hofstaedtler <zeha@debian.org>  Sat, 21 Dec 2013 23:33:59 +0100
